clear
clf
smt_init

load -mat mcphedran.gd
lambda = 1.45e-6;
k0 = 2*pi/lambda;
class = 'p4'; % McIsaacs's classification
positions = distribute(oGd);
positions = cut_pos(oGd, positions, class);
component = 'Hx';
method = 'direct';

Neff = 1.44539; % the fundamental mode
[error, solution] = smt_solve(Neff, oGd, positions, k0, method);
points = 150;
[maxX, minX, maxY, minY] = oGdRange(oGd);
a = 1.5; % enlarge calculation window by factor: a
x = linspace(minX*a, maxX*a, points);
y = linspace(minY*a, maxY*a, points);

field = calc_field(solution, positions, oGd, k0, Neff, component, class, x, y);
if isnan(field)
    return
end
imagesc(x, y, abs(field))
axis image
colorbar
draw_geom(oGd, 'noaxischange')
colormap pink