function [vNeff, vErr] = find_degs(vMin, vMax, minNeff, maxNeff, tol,...
    oGd, pos, k0, NEFF_FULL, ERR_FULL, absMinErr, complex, nSampMono, bPlot, sMethod, hAx, hWaitbar, maxNeffI)
global bCancel bSkip
curr_neff = 0;
curr_err = 0;
pot_degs = 0;
isImproper= complex==2;
if isempty(vMax)
    vMax = [minNeff maxNeff];
else
    if vMax(1) > vMin(1)
        vMax = [minNeff vMax];
    end
    if vMax(end) < vMin(end)
        vMax = [vMax maxNeff];
    end
end
vAll = sort([vMax vMin]);
vNeffDeg = [];
vErr = [];
iMode = 1;
while iMode <= length(vMin)
    prev_neff = inf;
    iInFull = find(NEFF_FULL==vMin(iMode));
    minLocal_small = NEFF_FULL(iInFull-1);
    maxLocal_small = NEFF_FULL(iInFull+1);
    iInAll = find(vAll==vMin(iMode));
    minLocal = vAll(iInAll-1);
    maxLocal = vAll(iInAll+1);
    bAdd = 1;
    temp = bPlot;
    bPlot = 0;
    cDone = -inf; % used in conjuction with fminsearchbnd to exit. -Inf is for fminbnd
    try
        [vMin(iMode), err_first] = fminbnd('smt_solve', minLocal_small, maxLocal_small,...
            optimset('TolX', tol/2, 'OutputFcn', @fine_search_cancel, 'Display', 'off'), oGd, pos, k0, sMethod, isImproper);
    catch
        vMin(iMode) = -1;
        vErr = [];
    end
    if bCancel
        cancel_cleanup
        return
    end
    if bSkip
        skip_cleanup
        return
    end
    bAdd = 0;
    bPlot = temp;
    iInFull = find(NEFF_FULL==vMin(iMode));
    d = max(vMin(iMode) - NEFF_FULL(iInFull-1), NEFF_FULL(iInFull+1)- vMin(iMode));
    minLocal_small = vMin(iMode)-2*d;
    maxLocal_small = vMin(iMode)+2*d;
    if complex
        x0  = j;
        while ~all(isreal(x0))
            N = 15;
            vX = linspace(minLocal_small, maxLocal_small, N);
            vY = zeros(1, N);
            for iX = 1:length(vX)
                if bCancel
                    cancel_cleanup
                    return
                end
                if bSkip
                    skip_cleanup
                    return
                end
                new_y = smt_solve(vX(iX), oGd, pos, k0, sMethod);
                vY(iX) = new_y;
            end
            x0 = estimate_beta(vX, vY);
            inX = local_maxima(1./vY);
            minLocal_small = vX(inX-1);
            maxLocal_small = vX(inX+1);
        end
        lower_bound = [minLocal, 1.5*x0(2)];
        if maxNeffI
            lower_bound(2) = maxNeffI;
        end
        upper_bound = [maxLocal, 0];
        %         [beta, err_first] = fmincon('smt_solve', x0,[],[],[],[],lower_bound, upper_bound,[],...
        %             optimset('TolX', tol, 'TolFun', 1e-300, 'TolCon', tol/100, 'DiffMinChange', tol/100, 'DiffMaxChange', tol/10,...
        %             'largescale','off', 'OutputFcn', @fine_search_cancel), oGd, pos, k0, isImproper, 'complex');
        cDone = 0;
        fun = @(x) smt_solve(x, oGd, pos, k0, sMethod, isImproper, 'complex');
        [beta, err_first] = fminsearchbnd(fun, x0,lower_bound, upper_bound,...
            optimset('TolX', tol, 'OutputFcn', @fine_search_cancel, 'Display', 'off'));
        

        %        fun = @(x) smt_solve(x, oGd, pos, k0, 0, 'complex');
        %        [beta, err_first] = fminzoom(fun, upper_bound, lower_bound, tol);

        neff = beta(1)+j*beta(2);
        %        con = [abs(real(neff) - lower_bound(1)) abs(real(neff) - upper_bound(1)) ...
        %            abs(imag(neff) - lower_bound(2)) abs(imag(neff) - upper_bound(2))];
        %         if abs(real(neff) - minLocal)<=tol || abs(real(neff) - maxLocal)<=tol ||...
        %                 abs(imag(neff) - lower_bound(2))<=tol || abs(imag(neff) - upper_bound(2))<=tol %converged to edge
        %             vMin = remove(vMin, iMode);
        %             continue
        %         end
        vMin(iMode) = neff;
        if bCancel
            cancel_cleanup
            return
        end
        if bSkip
            skip_cleanup
            return
        end
    end
    [dummy, mFilter] = smt_solve(vMin(iMode), oGd, pos, k0, sMethod, isImproper);
    if err_first > absMinErr
        vMin = remove(vMin, iMode);
        continue
    end
    vErr(end+1) = err_first;
    err_at_minLocal = ERR_FULL(NEFF_FULL==minLocal);
    err_at_maxLocal = ERR_FULL(NEFF_FULL==maxLocal);
    R = 10;
    minErr = min([err_at_minLocal, err_at_maxLocal]);
    err_deg = smt_solve_filtered(vMin(iMode), oGd, pos, k0, mFilter, minErr*R, isImproper);
    while (err_deg < minErr)
        pot_degs = pot_degs + 1;
        if complex
            %[beta, err_deg] = fmincon('smt_solve_filtered', x0,[],[],[],[],lower_bound, upper_bound,[],...
            %    optimset('TolX', tol, 'TolFun', 1e-300, 'TolCon', tol/100, 'DiffMinChange', tol/100, 'DiffMaxChange', tol/10,...
            %    'largescale', 'off', 'OutputFcn', @fine_search_cancel), oGd, pos, k0, mFilter, minErr*R, isImproper, 'complex');
            cDone = 0;
            fun = @(x) smt_solve_filtered(x, oGd, pos, k0, mFilter, minErr*R, isImproper, 'complex');
            [beta, err_deg] = fminsearchbnd(fun, x0, lower_bound, upper_bound,...
                optimset('Display', 'off', 'TolX', tol, 'OutputFcn', @fine_search_cancel));
            if bCancel
                cancel_cleanup
                return
            end
            if bSkip
                skip_cleanup
                return
            end
            neff_deg = beta(1) + j*beta(2);
            if (abs(real(neff_deg) - lower_bound(1))<=tol || ...
                    abs(real(neff_deg) - upper_bound(1))<=tol || abs(imag(neff_deg) - lower_bound(2))<=tol || ...
                    abs(imag(neff_deg) - upper_bound(2))<=tol) %converged to edge
                pot_degs = pot_degs -1;
                break
            end
        else
            fun = @(x) smt_solve_filtered(x, oGd, pos, k0, mFilter, minErr*R);
            [neff_deg, dummy, vNeff_full_deg, dummy] = find_modes_rec(minLocal, maxLocal, 0, 0, fun, nSampMono, bPlot, absMinErr, hAx, hWaitbar, 1);
            if isnan(neff_deg)
                cancel_cleanup
                return
            end
            if isempty(neff_deg)
                pot_degs = pot_degs -1;
                break
            end
            for iDeg = 1:length(neff_deg)
                left =  find(vNeff_full_deg < neff_deg(iDeg)); left = vNeff_full_deg(left(end));
                right =  find(vNeff_full_deg > neff_deg(iDeg)); right = vNeff_full_deg(right(1));
                cDone = -Inf;
                err_deg = zeros(1, length(neff_deg));
                [neff_deg(iDeg), err_deg(iDeg)] = fminbnd(fun, left, right, optimset('TolX', tol/10,...
                    'OutputFcn', @fine_search_cancel, 'Display', 'off'));
                if bCancel
                    cancel_cleanup
                    return
                end
                if bSkip
                    skip_cleanup
                    return
                end
            end
        end
        for iDeg = 1:length(neff_deg)
            if err_deg(iDeg) > absMinErr
                pot_degs = pot_degs -1;
                break
            end
            vNeffDeg(end+1) = neff_deg(iDeg);
            [err_deg(iDeg), vSol] = smt_solve_filtered(neff_deg(iDeg), oGd, pos, k0, mFilter, minErr*R, isImproper);
            vErr(end+1) = err_deg(iDeg);
            mFilter = [mFilter vSol];
            err_deg(iDeg) = smt_solve_filtered(neff_deg(iDeg), oGd, pos, k0, mFilter, minErr*R, isImproper);
        end
        err_deg = min(err_deg);
    end
    iMode = iMode+1;
end
[vNeff, iSrt] = sort([vMin vNeffDeg]);
vErr = vErr(iSrt);


    function stop = fine_search_cancel(beta, val, state, varargin)
        if ~isempty(beta)
            if length(beta)==2
                beta = beta(1)+j*beta(2);
            end
            curr_neff = beta;
            if abs(curr_neff - prev_neff) < tol
                this_mode_prog = 1;
                cDone = cDone + 1;
            else
                cDone = ~isinf(cDone);
                this_mode_prog = abs(log(abs(curr_neff-prev_neff)+eps))/abs(log(tol));
            end
            sDigits = num2str(-round(log10(tol))+1);
            sFormatR = ['%1.' sDigits 'g'];
            sFormatI = ['%1.' sDigits 'g'];
            sTitle = ['Searching in a small neighborhood around mode No. ' num2str(iMode) '...'];
            if ~isreal(beta)
                sTitle = [sTitle char(10) '$\beta/k_0$ = ' sprintf([sFormatR ' -j' sFormatI], real(beta), -imag(beta))...
                    ' $\Delta E$ = ' sprintf(sFormatR, val.fval)];
            else
                sTitle = [sTitle char(10) '$\beta/k_0$ = ' sprintf(sFormatR, real(beta))...
                    ' $\Delta E$ = ' sprintf(sFormatR, val.fval)];
            end
            waitbar(((iMode-1)+min(1, this_mode_prog))/(length(vMin)+pot_degs), hWaitbar, sTitle)
            prev_neff = curr_neff;
            curr_err = val.fval;
            if bAdd
                [NEFF_FULL, ERR_FULL] = unique_add(NEFF_FULL, ERR_FULL, curr_neff, curr_err);
            end
            %             if bPlot
            %                 x = real(NEFF_FULL);
            %                 y = imag(NEFF_FULL);
            %                 z = ERR_FULL;
            %                 N = 100;
            %                 xi = linspace(lower_bound(1), upper_bound(1), N);
            %                 yi = linspace(lower_bound(2), upper_bound(2), N);
            %                 %yi = linspace(min(y), max(y), N);
            %                 [XI, YI] = meshgrid(xi, yi);
            % %                zi = griddata(x,y,z,XI,YI);
            % %                imagesc(xi, yi, zi, 'parent', hAx)
            %                 set(hAx, 'ydir', 'normal');
            %                 hold on, plot(hAx, real(beta), imag(beta), 'r.')
            %                 plot(hAx, x, y, 'k.')
            %             end
        end
        drawnow
        if cDone == 10
            stop = 1;
        else
            stop= 0;
        end
        stop = stop || bCancel || bSkip;
    end
    
    function cancel_cleanup
        vNeff = -1;
        vErr = [];
    end

    function skip_cleanup
        iMin = local_maxima(1./ERR_FULL);
        vErr = ERR_FULL(iMin);
        vNeff = NEFF_FULL(iMin);
        [dummy, inNeff] = min(abs(real(vNeff-curr_neff)));
        if curr_neff ~= 0
            vNeff(inNeff) = curr_neff;
            vErr(inNeff) = curr_err;
        end
    end

end