nSourcesPerVein = 36;
a = 6.75e-6; % pitch in [m]
Rv = 2.5e-6; % vein radius [m]
type = 1; 
first = 1; % number of veins per hexagon side in the first ring
last = 1; % number of veins per hexagon side in the last ring
[vCx, vCy] = hex_centers(a, first, last, type);
Nv = length(vCx); % number of air veins
oGd.nSources = nSourcesPerVein*Nv;
oGd.nTestingPoints = oGd.nSources*1.5;
oGd.alphaIn = 0.3;
oGd.alphaOut = 0.3;
oGd.offsetX = 0;
oGd.offsetY = 0;
curve = primitive('circle', Rv);
curveArray = clone(vCx, vCy, curve);

oGd.curveArray = curveArray;
oGd.sdArray = compute_sd_array(curveArray);
oGd.nSd = length(oGd.sdArray);
vEr = [1.45^2 ones(1, oGd.nSd-1)];
for iSd = 1:oGd.nSd
    oGd.sdArray(iSd).Er = vEr(iSd);
end
oGd = orderfields(oGd);
save mcphedran.gd oGd
