function [maxX, minX, maxY, minY] = oGdRange(G)
% [maxX, minX, maxY, minY] = OGDRANGE(oGd)
% finds the limits in X and Y of the geometry oGd
maxX = -inf;
maxY = -inf;
minX = inf;
minY = inf;
for iCur = 1:length(G.curveArray)
    curve = G.curveArray(iCur);
    maxX = max(maxX, curve.max_x+curve.xc);
    maxY = max(maxY, curve.max_y+curve.yc);
    minX = min(minX, curve.min_x+curve.xc);
    minY = min(minY, curve.min_y+curve.yc);
end